# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph, Hooman Asadian, Sarbojit Das
# Assignment 2 - Implementation of Sorting Algorithms
import os
import array
import sys
import time #import time to calculate running time

# Bubble Sort:
def bubblesort(a):
    sorted = False
    while not sorted:
        sorted = True
        for i in range(len(a)-1):
            if a[i] > a[i+1]:
                swap(a, i, i+1)
                sorted = False

def swap(a, i, j):
    t = a[j]
    a[j] = a[i]
    a[i] = t


# This is the function to verify your implemented sorting algorithm
# You need to change it a bit to call your sorting algorithm
def test():
    # Check if nums.txt exists:
    if not os.path.exists('nums.txt'):
        print("First create nums.txt")
        sys.exit(0)

    # Read the content of nums.txt into an array, 'FH' is short for File Handle:
    numsFH = open('nums.txt', 'r')
    a = []
    for line in numsFH:
        a.append(int(str.strip(line)))

    # Sort the array using bubblesort and calculate running time:
    start=time.time()
    bubblesort(a)    # You need to change here to call your sorting algorithm
    end=time.time()
    print("bubblesort running time:   ",end-start)
    numsFH.close()
    
    # Output bubble-sorted.txt:
    nums_sortedFH = open('bubble-sorted.txt', 'w')
    for element in a:
        nums_sortedFH.write(str(element) + "\n")
    # nums_sortedFH.write("100\n")

    numsFH.close()
    nums_sortedFH.close()

    # Compare 'bubble-sorted.txt' with sorting by the operating system, 'nums_ref.txt':
    os.system('sort -n nums.txt > nums_ref.txt')
    ret = os.system('diff bubble-sorted.txt nums_ref.txt > tmp.txt')

    # Tell the user whether your sorting succeded or failed:
    if int(ret) == 0:
        print("Sorted!")
    if int(ret) != 0:
        print("Not sorted!")

# python bubblesort.py runs test
if __name__ == "__main__":
    test()
