# Uppsala University - Algorithms and Data Structures 1, 1DL210
# Copyright (c) 2020 Henrik Alfken(Schulze), Neethu Joseph, Hooman Asadian, Sarbojit Das
# Assignment 2 - Implementation of Sorting Algorithms
import matplotlib.pyplot as plt
import matplotlib.ticker as ticker

x = [1000,10000,20000]
bubblesort    = [0.128, 13.818, 55.969]
insertionsort = [0.039,  4.212, 15.926]
heapsort      = [0.006,  0.051,  0.119]
quicksort     = [0.003,  0.028,  0.055]

plt.plot(x,bubblesort,'r^',label='bubblesort')
plt.plot(x,insertionsort,'ks',label='insertion sort')
plt.plot(x,heapsort,'bo',label='heapsort')
plt.plot(x,quicksort,'g+',label='quicksort')
plt.title('Four sorting algorithms for three different data sizes.')
plt.legend(loc="lower right")
plt.xlabel('Data size = number of elements to sort')
plt.yscale('log')
plt.ylabel('Time in seconds to sort the data')
plt.gca().yaxis.set_major_formatter(ticker.FormatStrFormatter('%.1f s'))
plt.show()

#   In the command line:
# $ python matplotlib-4algos.py
